#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <PubSubClient.h>

// Update these with values suitable for your network.
#define load1 0 //GO0
#define input1 3 //GO3

bool buttonPushed;


ESP8266WiFiMulti WiFiMulti;
static const char ssid[] = "SSID";
static const char password[] = "PWD";

const char* mqtt_server = "192.168.21.125";

WiFiClient espClient;
PubSubClient client(espClient);

long lastMsg = 0;
char msg[50];
int value = 0;

int last_pub_time = 0;

bool beeping;

void setup_wifi() {

  delay(10);
  // We start by connecting to a WiFi network
  WiFiMulti.addAP(ssid, password);

  while (WiFiMulti.run() != WL_CONNECTED) {
    delay(100);
  }

  randomSeed(micros());

}

void callback(char* topic, byte* payload, unsigned int length) {

  if ((char)payload[0] == '3') {
    beeping = true;
  }
  else  {
    beeping = false;
  }

}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    // Create a random client ID
    String clientId = "lens_5kchta2dWhdRS2AQz0TeTuhplPE";
    clientId += String(random(0xffff), HEX);
    // Attempt to connect
    if (client.connect(clientId.c_str(), "openhabian", "openhabian")) {
      // Once connected, publish an announcement...
      // client.publish("outTopic", "hello world");
      // ... and resubscribe
      client.subscribe("/home/esp8266/switch/command");
    } else {
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}

void setup() {

  pinMode(load1, OUTPUT);
  digitalWrite(load1, HIGH);  //Turn buzzer off on startup

  pinMode(input1, INPUT_PULLUP);

  setup_wifi();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);

  //Sound to confirm successful wifi connection
  digitalWrite(load1, LOW);
  delay(500);
  digitalWrite(load1, HIGH);

  //Rest switch on webportal
  if (!client.connected()) {
    reconnect();
  }
  client.publish("/home/esp8266/switch/state", "2");

}

void soundAlarm() {
  digitalWrite(load1, LOW);
  delay(1000);
  digitalWrite(load1, HIGH);
  delay(1000);

}

void loop() {
  if (beeping) soundAlarm();
  if (!client.connected()) {
    reconnect();
  }
  buttonPushed = !digitalRead(input1);
  if (buttonPushed) {
    client.publish("/home/esp8266/switch/state", "2");
    beeping = false;
  }
  client.loop();
}
